#!/usr/bin/env python 
'''
Copyright (C) 2006 Olivier Gondouin, popolon@popolon.org

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'''
import inkex, simplepath, simplestyle, copy

class OpaqueMask(inkex.Effect):
    def effect(self):
        for id, node in self.selected.iteritems():
            if node.tagName == 'path':
              # warning, cloneNode keep id, old node change id
              idold = node.getAttribute('id')
              new = node.cloneNode('true')

              # define style and attributes
              s = {'stroke': 'none',
                   'fill': '#ffffff',
                   'fill-ocpacity': '1'}
              new.setAttribute('style', simplestyle.formatStyle(s))
              if new.hasAttribute('mask'):
                new.removeAttribute('mask')

              new.setAttribute('xlink:href', '#'+idold)
              new.setAttribute('inkscape:href', idold)
              new.setAttribute('inkscape:radius', '0')
              new.setAttribute('sodipodi:type', 'inkscape:offset')

                # a special id is given to avoid to loose link of the
                # linked offset (the clone keep the original id, and, as
                # it is before the original in the xml file, inkscape
                # change it's id to avoid to have two objects with the
                # same id.
              new.setAttribute('id','99999')

              #	make a simple linked offset could be the best solution,
              # but in inkscape-0.44.1 the linked offset doesn't follow
              #	a masked object position ???
#              node.parentNode.appendChild(new)
#              node.parentNode.insertBefore(new,node)
              # Then to keep objects together, we
              # create a group with both object
              newgroup = self.document.createElement('svg:g')
              node.parentNode.insertBefore(newgroup,node)
              newgroup.appendChild(new)
              newgroup.appendChild(node)

e = OpaqueMask()
#e.output()
e.affect()
